// Do NOT add a package declaration here.

import edu.kit.iti.formal.lights.LightUpSolver;
import edu.kit.iti.formal.lights.Lights;
import edu.kit.iti.formal.lights.Solution;
import org.sat4j.core.VecInt;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.TimeoutException;

/**
 * This class provides a template for your own solution to the assignment.
 * <p>
 * The source code is added in the jar file.
 * Please consult it for detailed information.
 *
 * @author **YOUR NAME HERE**
 */
public class MyLightUpSolver extends LightUpSolver {
    public MyLightUpSolver(Lights lights) {
        super(lights);
    }

    @Override
    public Solution solve() throws ContradictionException, TimeoutException {
        // 1. Calculate the set of clauses for the given game.
        // You can access the current game instance with:
        lights.isBlock(0, 1);

        //add clauses with a helper
        addClause(-1, 2);
        //or directly
        solver.addClause(new VecInt(new int[]{2, 3, 4, 5}));

        // 2. Request a model by SAT solver.
        int[] result = solver.findModel();
        if (result != null) { // SAT solver found a model
            //3a. Interpret SAT solver result to find the correct lamps positions.
            //You can use the already instantiated empty Solution object.
            solution.addLamp(0, 0); //remove this light
            return solution;
        } else {//3b. unsatisfiable
            return null;
        }
    }


    /**
     * Adds the given literals as one clause to the sat solver instance.
     *
     * @param c the literals
     */
    private void addClause(int... c) throws ContradictionException {
        // Debugging:
        // System.out.println(Arrays.toString(c));
        solver.addClause(new VecInt(c));
    }
}
